using System;
using System.Collections.Generic;
using System.Text;

namespace Polynomdivision
{
    class Program
    {
        static void Main(string[] args)
        {
            double[] numerator = new double[] { -2, 3, -5, 4 };
            Console.WriteLine("Numerator:");
            printPolynomial(numerator);

            double[] denominator = new double[] { -1, 0, 2 };
            Console.WriteLine("Denominator:");
            printPolynomial(denominator);

            double[] quotient = new double[numerator.Length - denominator.Length + 1];
            for (int i = numerator.Length - 1; i >= denominator.Length - 1; i--)
            {
                // work with x^i in the numerator
                double r = numerator[i] / denominator[denominator.Length - 1];
                quotient[i - (denominator.Length - 1)] = r;

                // subtract r*denominator
                for (int j = 0; j < denominator.Length; j++)
                {
                    // work with x^j in the denominator
                    numerator[j + i - (denominator.Length - 1)] -= r * denominator[j];
                }
            }

            Console.WriteLine("Quotient:");
            printPolynomial(quotient);

            Console.WriteLine("Remainder:");
            printPolynomial(numerator); // what's left of the numerator

            Console.ReadLine();
        }

        private static void printPolynomial(double[] polynomial)
        {
            for (int i = polynomial.Length - 1; i >= 0; i--)
            {
                Console.Write((i == polynomial.Length - 1 ? " " : " + ") + polynomial[i] + (i >= 2 ? " x^" + i : (i == 1 ? " x" : "")));
            }
            Console.WriteLine();
        }
    }
}
